/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2015 Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.ASTY=e()}}(function(){return function e(t,n,r){function o(a,u){if(!n[a]){if(!t[a]){var f="function"==typeof _dereq_&&_dereq_;if(!u&&f)return f(a,!0);if(i)return i(a,!0);var s=new Error("Cannot find module '"+a+"'");throw s.code="MODULE_NOT_FOUND",s}var c=n[a]={exports:{}};t[a][0].call(c.exports,function(e){var n=t[a][1][e];return o(n?n:e)},c,c.exports,e,t,n,r)}return n[a].exports}for(var i="function"==typeof _dereq_&&_dereq_,a=0;a<r.length;a++)o(r[a]);return o}({1:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function(){function e(){r(this,e)}return o(e,[{key:"init",value:function(e,t,n){if("undefined"==typeof e)throw new Error("init: invalid argument");if(this.ASTy=!0,this.T=e,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"==typeof t)for(var r in t)t.hasOwnProperty(r)&&this.set(r,t[r]);return"object"==typeof n&&n instanceof Array&&this.add(n),this}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,t,n){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=t||0,this.L.O=n||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){var e=arguments,t=this;if(1===arguments.length&&"object"==typeof arguments[0])!function(){var n=e;Object.keys(n[0]).forEach(function(e){t.A[e]=n[0][e]})}();else{if(2!==arguments.length)throw new Error("set: invalid arguments");this.A[arguments[0]]=arguments[1]}return this}},{key:"get",value:function(e){if(1!==arguments.length)throw new Error("get: invalid number of arguments");if("string"!=typeof e)throw new Error("get: invalid argument");return this.A[e]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"add",value:function(){var e=this;if(0===arguments.length)throw new Error("add: missing argument(s)");var t=function(e,t){if(!("object"==typeof t&&"string"==typeof t.T&&"object"==typeof t.L&&"object"==typeof t.A&&"object"==typeof t.P&&"object"==typeof t.C&&t.C instanceof Array))throw new Error("add: invalid AST node: "+JSON.stringify(t));e.C.push(t),t.P=e};return null!==arguments&&Array.prototype.slice.call(arguments,0).forEach(function(n){"object"==typeof n&&n instanceof Array?n.forEach(function(n){t(e,n)}):null!==n&&t(e,n)}),this}},{key:"del",value:function(){var e=this;if(0===arguments.length)throw new Error("del: invalid argument");return Array.prototype.slice.call(arguments,0).forEach(function(t){for(var n=!1,r=0;r<e.C.length;r++)if(e.C[r]===t){e.C.splice(r,1),t.P=null,n=!0;break}if(!n)throw new Error("del: child not found")}),this}},{key:"childs",value:function(){return this.C}},{key:"parent",value:function(){return this.P}}]),e}();n["default"]=i,t.exports=n["default"]},{}],2:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function(){function e(){r(this,e)}return o(e,[{key:"dump",value:function(e){void 0===e&&(e=1/0);var t="";return this.walk(function(n,r){if(!(r>e)){for(var o=0;r>o;o++)t+="    ";t+=n.T+" ";var i=Object.keys(n.A);i.length>0&&!function(){t+="(";var e=!0;i.forEach(function(r){e?e=!1:t+=", ",t+=r+": ";var o=n.A[r];switch(typeof o){case"string":var i=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};t+='"'+o.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+i(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+i(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+i(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+i(e)})+'"';break;case"object":t+=o instanceof RegExp?o.source:JSON.stringify(o);break;default:t+=JSON.stringify(o)}}),t+=") "}(),t+="["+n.L.L+"/"+n.L.C+"]\n"}},"downward"),t}}]),e}();n["default"]=i,t.exports=n["default"]},{}],3:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function(){function e(){r(this,e)}return o(e,[{key:"merge",value:function(e,t,n){var r=this;if("object"!=typeof e)throw new Error("merge: invalid AST node argument");if("undefined"==typeof t&&(t=!1),"undefined"==typeof n&&(n={}),t){var o=e.pos();this.pos(o.L,o.C,o.O)}return e.attrs().forEach(function(t){var o="undefined"!=typeof n[t]?n[t]:t;null!==o&&r.set(o,e.get(t))}),e.childs().forEach(function(e){r.add(e)}),this}}]),e}();n["default"]=i,t.exports=n["default"]},{}],4:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function(){function e(){r(this,e)}return o(e,null,[{key:"serialize",value:function(e,t){var n=function r(e){var t={T:e.T,L:{L:e.L.L,C:e.L.C,O:e.L.O}},n=Object.keys(e.A);return n.length>0&&(t.A={},n.forEach(function(n){var r=e.A[n];switch(typeof r){case"boolean":case"number":case"string":t.A[n]=r;break;default:t.A[n]=JSON.parse(JSON.stringify(r))}})),e.C.length>0&&(t.C=e.C.map(function(e){return r(e)})),t};if(!e.isA(t))throw new Error("failed to serialize: not an ASTy node");return JSON.stringify({ASTy:n(t)})}},{key:"unserialize",value:function(e,t){var n=function o(t){var n=e.create(t.T);return n.pos(t.L.L,t.L.C,t.L.O),"object"==typeof t.A&&Object.keys(t.A).forEach(function(e){var r=t.A[e];switch(typeof r){case"boolean":case"number":case"string":n.set(e,r);break;default:n.set(e,JSON.parse(JSON.stringify(r)))}}),"object"==typeof t.C&&t.C instanceof Array&&n.add(t.C.map(function(e){return o(e)})),n},r=JSON.parse(t);if("object"!=typeof r||"object"!=typeof r.ASTy)throw new Error("failed to unserialize: not an ASTy JSON export");return n(r.ASTy)}}]),e}();n["default"]=i,t.exports=n["default"]},{}],5:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var r={major:1,minor:2,micro:1,date:20150801};n["default"]=r,t.exports=n["default"]},{}],6:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),i=function(){function e(){r(this,e)}return o(e,[{key:"walk",value:function(e,t){"undefined"==typeof t&&(t="downward");var n=function r(n,o,i){("downward"===t||"both"===t)&&e.call(null,n,o,i,"downward"),n.C.forEach(function(e){r(e,o+1,n)}),("upward"===t||"both"===t)&&e.call(null,n,o,i,"upward")};return n(this,0,null),this}}]),e}();n["default"]=i,t.exports=n["default"]},{}],7:[function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{"default":e}}function o(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),a=e("./asty-base.js"),u=r(a),f=e("./asty-merge.js"),s=r(f),c=e("./asty-walk.js"),l=r(c),d=e("./asty-dump.js"),y=r(d),p=e("./asty-serialize.js"),h=r(p),v=e("./asty-version.js"),g=r(v),b=function(){function e(){var t=this;o(this,e),this.ASTYNode=function(){};var n=[[u["default"],"init","type","pos","set","get","attrs","add","del","childs","parent"],[s["default"],"merge"],[l["default"],"walk"],[y["default"],"dump"]];return n.forEach(function(e){var n=e[0].prototype;e.slice(1).forEach(function(e){t.ASTYNode.prototype[e]=n[e]})}),this}return i(e,[{key:"version",value:function(){return g["default"]}},{key:"extend",value:function(e){for(var t in e)e.hasOwnProperty(t)&&(this.ASTYNode.prototype[t]=e[t]);return this}},{key:"create",value:function(e){return(new this.ASTYNode).init(e)}},{key:"isA",value:function(e){return"object"==typeof e&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&e.ASTy===!0}},{key:"serialize",value:function(e){return h["default"].serialize(this,e)}},{key:"unserialize",value:function(e){return h["default"].unserialize(this,e)}}]),e}();n["default"]=b,t.exports=n["default"]},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],2:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.CacheLRU=e()}}(function(){return function e(t,n,i){function r(u,s){if(!n[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var a=new Error("Cannot find module '"+u+"'");throw a.code="MODULE_NOT_FOUND",a}var h=n[u]={exports:{}};t[u][0].call(h.exports,function(e){var n=t[u][1][e];return r(n?n:e)},h,h.exports,e,t,n,i)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<i.length;u++)r(i[u]);return r}({1:[function(e,t,n){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),o=function(){function e(){return i(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return r(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var n=0,i=this._MRU.older;i!==this._LRU;)e.call(t,i.val,i.key,n++),i=i.older;return t}},{key:"has",value:function(e){var t=this._index[e];return void 0!==t}},{key:"peek",value:function(e){var t=this._index[e];return void 0===t?void 0:t.expires<Date.now()?void this.del(t.key):t.val}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];return void 0===t?void 0:t.expires<Date.now()?void this.del(t.key):(this._promote(t),t.val)}},{key:"set",value:function(e,t,n){arguments.length<3&&(n=1/0),n+=Date.now();var i=this._index[e];if(void 0===i)i={older:null,newer:null,key:e,val:t,expires:n},this._index[e]=i,this._attach(i),this._cur++,this._purge();else{var r=i.val;i.val=t,this._promote(i),this._dispose.call(void 0,i.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();n["default"]=o,t.exports=n["default"]},{}]},{},[1])(1)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],3:[function(_dereq_,module,exports){
(function (global){
!function(e,n,r){"function"==typeof define&&"undefined"!=typeof define.amd?define(n,function(){return r(e)}):"object"==typeof module&&"object"==typeof module.exports?module.exports=r(e):e[n]=r(e)}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,"PEGUtil",function(){var e={};e.makeAST=function(e,n,r,t){return function(){return t.util.__makeAST.call(null,e(),n(),r(),arguments)}},e.makeUnroll=function(e,n,r,t){return function(o,u,l){if("object"!=typeof u||!(u instanceof Array))throw new t("unroll: invalid list argument for unrolling",typeof u,"Array",r(),e(),n());if("undefined"!=typeof l){"number"==typeof l&&(l=[l]);var a=[];null!==o&&a.push(o);for(var i=0;i<u.length;i++)for(var f=0;f<l.length;f++)a.push(u[i][l[f]]);return a}return null!==o&&u.unshift(o),u}};var n=function(e,n){var r=e.length,t=n-20;0>t&&(t=0);var o=n+20;o>r&&(o=r);var u=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},l=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+u(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+u(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+u(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+u(e)})};return{prolog:l(e,t,n-t),token:l(e,n,1),epilog:l(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if("undefined"!=typeof o&&"object"!=typeof o)throw new Error("invalid options (not an object)");"undefined"==typeof o&&(o={});var u={ast:null,error:null};try{var l;l="function"==typeof o.makeAST?o.makeAST:function(e,n,r,t){return{line:e,column:n,offset:r,args:t}};var a={util:{makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:l}};"string"==typeof o.startRule&&(a.startRule=o.startRule),u.ast=r.parse(t,a),u.error=null}catch(i){u.ast=null;var f=function(e,n){return"undefined"!=typeof e?e:n};u.error={line:f(i.line,0),column:f(i.column,0),message:i.message,found:f(i.found,""),expected:f(i.expected,""),location:n(t,f(i.offset,0))}}return u},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",u=0;u<t.length+r.prolog.length;u++)o+="-";var l=t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n");return l},e});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],4:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),ASTQAdapterASTY=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();exports["default"]=ASTQAdapterASTY,module.exports=exports["default"];
},{}],5:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),ASTQAdapterMozAST=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof e&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if("undefined"!=typeof e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,n=[],o=function(e,t){e.hasOwnProperty(t)&&r.taste(e[t])?n.push(e[t]):e.hasOwnProperty(t)&&"object"==typeof e[t]&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&n.push(e)})};if("*"===t)for(var a in e)o(e,a);else{if("undefined"==typeof e[t])throw new Error('no such axis named "'+t+'" for walking to child nodes');o(e,t)}return n}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)e.hasOwnProperty(r)&&"object"!=typeof e[r]&&"type"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return e.hasOwnProperty(t)&&"object"!=typeof e[t]&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports["default"]=ASTQAdapterMozAST,module.exports=exports["default"];
},{}],6:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),ASTQAdapterXMLDOM=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof Node&&e instanceof Node&&"object"==typeof e&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return e.childNodes}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){return Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName})}},{key:"getNodeAttrValue",value:function(e,t){return e.getAttribute(t)}}]),e}();exports["default"]=ASTQAdapterXMLDOM,module.exports=exports["default"];
},{}],7:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),ASTQAdapter=function(){function e(){return _classCallCheck(this,e),this._adapters=[],this}return _createClass(e,[{key:"register",value:function(e){return this._adapters.unshift(e),this}},{key:"unregister",value:function(e){if(void 0===e)this._adapters=[];else{for(var t=[],r=0;r<this._adapters.length;r++)this._adapters[r]!==e&&t.push(this._adapters[r]);this._adapters=t}return this}},{key:"select",value:function(e){for(var t=0;t<this._adapters.length;t++)if(this._adapters[t].taste(e))return this._adapters[t];return void 0}}]),e}();exports["default"]=ASTQAdapter,module.exports=exports["default"];
},{}],8:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var stdfuncs={type:function(t,e){return t.getNodeType(e)},depth:function t(e,n){for(var t=1,r=n;null!==(r=e.getParentNode(r,"*"));)t++;return t},pos:function(t,e){var n=t.getParentNode(e,"*");if(null===n)return 1;for(var r=t.getChildNodes(n,"*"),o=0;o<r.length;o++)if(r[o]===e)return o+1;throw new Error("cannot find myself")},nth:function(t,e,n){n=parseInt(n,10);var r=t.getParentNode(e,"*");if(null!==r){var o=t.getChildNodes(r,"*");0>n&&(n=o-(n+1));for(var u=0;u<o.length;u++)if(o[u]===e)return u+1===n;return!1}return 1===n?!0:!1},first:function(t,e){return stdfuncs.nth(t,e,1)},last:function(t,e){return stdfuncs.nth(t,e,-1)},count:function(t,e,n){return"object"==typeof n&&n instanceof Array?n.length:"object"==typeof n?Object.keys(n).length:"string"==typeof n?n.length:String(n).length},substr:function(t,e,n,r,o){return String(n).substr(r,o)},lc:function(t,e,n){return String(n).toLowerCase()},uc:function(t,e,n){return String(n).toUpperCase()}};exports["default"]=stdfuncs,module.exports=exports["default"];
},{}],9:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}(),ASTQFuncs=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,n){this._funcs[e]=n}},{key:"run",value:function(e,n){var t=this._funcs[e];if("function"!=typeof t)throw new Error('invalid function "'+e+'"');return t.apply(null,n)}}]),e}();exports["default"]=ASTQFuncs,module.exports=exports["default"];
},{}],10:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_get=function(e,t,r){for(var a=!0;a;){var i=e,c=t,n=r;s=u=l=void 0,a=!1,null===i&&(i=Function.prototype);var s=Object.getOwnPropertyDescriptor(i,c);if(void 0!==s){if("value"in s)return s.value;var l=s.get;return void 0===l?void 0:l.call(n)}var u=Object.getPrototypeOf(i);if(null===u)return void 0;e=u,t=c,r=n,a=!0}},_astqUtilJs=_dereq_("./astq-util.js"),_astqUtilJs2=_interopRequireDefault(_astqUtilJs),_astqQueryTraceJs=_dereq_("./astq-query-trace.js"),_astqQueryTraceJs2=_interopRequireDefault(_astqQueryTraceJs),ASTQQueryExec=function(e){function t(e,r,a,i){_classCallCheck(this,t),_get(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this.adapter=e,this.params=r,this.funcs=a,this.trace=i}return _inherits(t,e),_createClass(t,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t];return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t}),this.traceEnd(e,t,a),a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,c=null,n=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(c=a[s++]),s<a.length&&"Filter"===a[s].type()&&(n=a[s++]),null===c)throw new Error("no matching part in query step");var l=[],u=c.get("id"),o=function(e){var t=r.adapter.getNodeType(e);if("*"===u||u===t){var a=!0;null!==n&&(r.execFilter(n,e)||(a=!1)),a&&l.push(e)}};return null!==i?!function(){var e=i.get("op"),a=i.get("type");if("/"===e)r.adapter.getChildNodes(t,a).forEach(function(e){return o(e)});else if("//"===e)!function(){var e=function i(e){o(e),r.adapter.getChildNodes(e,a).forEach(function(e){return i(e)})};r.adapter.getChildNodes(t,a).forEach(function(t){return e(t)})}();else if("-/"===e){var c=r.adapter.getParentNode(t,"*");if(null!==c){for(var n=r.adapter.getChildNodes(c,a),s=null,l=0;l<n.length&&n[l]!==t;l++)s=n[l];o(s)}}else if("-//"===e){var u=r.adapter.getParentNode(t,"*");if(null!==u)for(var n=r.adapter.getChildNodes(u,a),h=0;h<n.length&&n[h]!==t;h++)o(n[h])}else if("+/"===e){var d=r.adapter.getParentNode(t,"*");if(null!==d){var n=r.adapter.getChildNodes(d,a),f=void 0;for(f=0;f<n.length&&n[f]!==t;f++);f<n.length&&(f++,o(n[f]))}}else if("+//"===e){var p=r.adapter.getParentNode(t,"*");if(null!==p){var n=r.adapter.getChildNodes(p,a),x=void 0;for(x=0;x<n.length&&n[x]!==t;x++);if(x<n.length)for(x++;x<n.length;)o(n[x++])}}else if("../"===e){var v=r.adapter.getParentNode(t,a);null!==v&&o(v)}else if("..//"===e)for(var g=t;;){var E=r.adapter.getParentNode(g,a);if(null===E)break;o(E),g=E}}():o(t),this.traceEnd(e,t,l),l}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtilJs2["default"].truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtilJs2["default"].truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtilJs2["default"].truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":r=_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[0],t)),r&&(r=r&&_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[1],t)));break;case"||":r=_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[0],t)),r||(r=r||_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r=_astqUtilJs2["default"].coerce(this.execExpr(e.childs()[0],t),"number"),a=_astqUtilJs2["default"].coerce(this.execExpr(e.childs()[1],t),"number"),i=void 0;switch(e.get("op")){case"&":i=r&a;break;case"|":i=r|a;break;case"<<":i=r<<a;break;case">>":i=r>>a}return this.traceEnd(e,t,i),i}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"==":i=r===a;break;case"!=":i=r!==a;break;case"<=":i=_astqUtilJs2["default"].coerce(r,"number")<=_astqUtilJs2["default"].coerce(a,"number");break;case">=":i=_astqUtilJs2["default"].coerce(r,"number")>=_astqUtilJs2["default"].coerce(a,"number");break;case"<":i=_astqUtilJs2["default"].coerce(r,"number")<_astqUtilJs2["default"].coerce(a,"number");break;case">":i=_astqUtilJs2["default"].coerce(r,"number")>_astqUtilJs2["default"].coerce(a,"number");break;case"=~":i=null!==_astqUtilJs2["default"].coerce(r,"string").match(_astqUtilJs2["default"].coerce(a,"regexp"));break;case"!~":i=null===_astqUtilJs2["default"].coerce(r,"string").match(_astqUtilJs2["default"].coerce(a,"regexp"))}return this.traceEnd(e,t,i),i}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"+":i="string"==typeof r?r+_astqUtilJs2["default"].coerce(a,"string"):_astqUtilJs2["default"].coerce(r,"number")+_astqUtilJs2["default"].coerce(a,"number");break;case"-":i=_astqUtilJs2["default"].coerce(r,"number")+_astqUtilJs2["default"].coerce(a,"number");break;case"*":i=_astqUtilJs2["default"].coerce(r,"number")*_astqUtilJs2["default"].coerce(a,"number");break;case"/":i=_astqUtilJs2["default"].coerce(r,"number")/_astqUtilJs2["default"].coerce(a,"number");break;case"%":i=_astqUtilJs2["default"].coerce(r,"number")%_astqUtilJs2["default"].coerce(a,"number");break;case"**":i=Math.pow(_astqUtilJs2["default"].coerce(r,"number"),_astqUtilJs2["default"].coerce(a,"number"))}return this.traceEnd(e,t,i),i}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=void 0;switch(e.get("op")){case"!":a=!_astqUtilJs2["default"].coerce(r,"boolean");break;case"~":a=~_astqUtilJs2["default"].coerce(r,"number")}return this.traceEnd(e,t,a),a}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var c=this.funcs.run(a,i);return this.traceEnd(e,t,c),c}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if("undefined"==typeof this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),t}(_astqQueryTraceJs2["default"]);exports["default"]=ASTQQueryExec,module.exports=exports["default"];
},{"./astq-query-trace.js":11,"./astq-util.js":13}],11:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_astqUtilJs=_dereq_("./astq-util.js"),_astqUtilJs2=_interopRequireDefault(_astqUtilJs),ASTQQueryTrace=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,a=e;null!==(a=a.parent());)r++;var i=_astqUtilJs2["default"].pad("",4*r);for(r=0,a=t;null!==(a=this.adapter.getParentNode(a,"*"));)r++;var n=_astqUtilJs2["default"].pad("",4*r);return{prefix1:i,prefix2:n}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),a=r.prefix1,i=r.prefix2;console.log("ASTQ: execute: | "+_astqUtilJs2["default"].pad(a+e.type()+" (",-60)+" | "+i+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var a=this;if(this.trace){var i=this.prefixOf(e,t),n=i.prefix1,l=i.prefix2,o=void 0;void 0===r?o="undefined":"object"==typeof r&&r instanceof Array?(o="[",r.forEach(function(e){o+="node("+a.adapter.getNodeType(e)+"),"}),o=o.replace(/,$/,"")+"]"):o=typeof r+"("+r+")",o.length>60&&(o=o.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtilJs2["default"].pad(n+"): "+o,-60)+" | "+l+this.adapter.getNodeType(t))}}}]),e}();exports["default"]=ASTQQueryTrace,module.exports=exports["default"];
},{"./astq-util.js":13}],12:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(t){return t&&t.__esModule?t:{"default":t}}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function t(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}}(),_astqQueryExecJs=_dereq_("./astq-query-exec.js"),_astqQueryExecJs2=_interopRequireDefault(_astqQueryExecJs),ASTY=_dereq_("asty"),PEGUtil=_dereq_("pegjs-util"),ASTQQueryParse=function(){function t(t,e){function r(){this.constructor=t}r.prototype=e.prototype,t.prototype=new r}function e(t,e,r,n,s,u){this.message=t,this.expected=e,this.found=r,this.offset=n,this.line=s,this.column=u,this.name="SyntaxError"}function r(t){function r(){return is}function n(){return i(is).line}function s(){return i(is).column}function u(t){throw l(t,null,is)}function i(e){function r(e,r,n){var s,u;for(s=r;n>s;s++)u=t.charAt(s),"\n"===u?(e.seenCR||e.line++,e.column=1,e.seenCR=!1):"\r"===u||"\u2028"===u||"\u2029"===u?(e.line++,e.column=1,e.seenCR=!0):(e.column++,e.seenCR=!1)}return as!==e&&(as>e&&(as=0,ls={line:1,column:1,seenCR:!1}),r(ls,as,e),as=e),ls}function a(t){os>us||(us>os&&(os=us,cs=[]),cs.push(t))}function l(r,n,s){function u(t){var e=1;for(t.sort(function(t,e){return t.description<e.description?-1:t.description>e.description?1:0});e<t.length;)t[e-1]===t[e]?t.splice(e,1):e++}function a(t,e){function r(t){function e(t){return t.charCodeAt(0).toString(16).toUpperCase()}return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(t){return"\\x0"+e(t)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(t){return"\\x"+e(t)}).replace(/[\u0180-\u0FFF]/g,function(t){return"\\u0"+e(t)}).replace(/[\u1080-\uFFFF]/g,function(t){return"\\u"+e(t)})}var n,s,u,i=new Array(t.length);for(u=0;u<t.length;u++)i[u]=t[u].description;return n=t.length>1?i.slice(0,-1).join(", ")+" or "+i[t.length-1]:i[0],s=e?'"'+r(e)+'"':"end of input","Expected "+n+" but "+s+" found."}var l=i(s),o=s<t.length?t.charAt(s):null;return null!==n&&u(n),new e(null!==r?r:a(n,o),n,o,s,l.line,l.column)}function o(){var t,e,r,n,s,u=37*us+0,i=fs[u];return i?(us=i.nextPos,i.result):(t=us,e=V(),e!==Y?(r=c(),r!==Y?(n=V(),n!==Y?(s=G(),s!==Y?(is=t,e=W(r),t=e):(us=t,t=K)):(us=t,t=K)):(us=t,t=K)):(us=t,t=K),fs[u]={nextPos:us,result:t},t)}function c(){var e,r,n,s,u,i,l,o,c=37*us+1,f=fs[c];if(f)return us=f.nextPos,f.result;if(e=us,r=p(),r!==Y){for(n=[],s=us,u=V(),u!==Y?(44===t.charCodeAt(us)?(i=X,us++):(i=Y,0===ps&&a(tt)),i!==Y?(l=V(),l!==Y?(o=p(),o!==Y?(u=[u,i,l,o],s=u):(us=s,s=K)):(us=s,s=K)):(us=s,s=K)):(us=s,s=K);s!==Y;)n.push(s),s=us,u=V(),u!==Y?(44===t.charCodeAt(us)?(i=X,us++):(i=Y,0===ps&&a(tt)),i!==Y?(l=V(),l!==Y?(o=p(),o!==Y?(u=[u,i,l,o],s=u):(us=s,s=K)):(us=s,s=K)):(us=s,s=K)):(us=s,s=K);n!==Y?(is=e,r=et(r,n),e=r):(us=e,e=K)}else us=e,e=K;return fs[c]={nextPos:us,result:e},e}function p(){var t,e,r,n,s,u,i=37*us+2,a=fs[i];if(a)return us=a.nextPos,a.result;if(t=us,e=f(),e!==Y){for(r=[],n=us,s=V(),s!==Y?(u=d(),u!==Y?(s=[s,u],n=s):(us=n,n=K)):(us=n,n=K);n!==Y;)r.push(n),n=us,s=V(),s!==Y?(u=d(),u!==Y?(s=[s,u],n=s):(us=n,n=K)):(us=n,n=K);r!==Y?(is=t,e=rt(e,r),t=e):(us=t,t=K)}else us=t,t=K;return fs[i]={nextPos:us,result:t},t}function f(){var t,e,r,n,s,u,i=37*us+3,a=fs[i];return a?(us=a.nextPos,a.result):(t=us,e=h(),e===Y&&(e=nt),e!==Y?(r=V(),r!==Y?(n=A(),n!==Y?(s=V(),s!==Y?(u=y(),u===Y&&(u=nt),u!==Y?(is=t,e=st(e,n,u),t=e):(us=t,t=K)):(us=t,t=K)):(us=t,t=K)):(us=t,t=K)):(us=t,t=K),fs[i]={nextPos:us,result:t},t)}function d(){var t,e,r,n,s,u,i=37*us+4,a=fs[i];return a?(us=a.nextPos,a.result):(t=us,e=h(),e!==Y?(r=V(),r!==Y?(n=A(),n!==Y?(s=V(),s!==Y?(u=y(),u===Y&&(u=nt),u!==Y?(is=t,e=st(e,n,u),t=e):(us=t,t=K)):(us=t,t=K)):(us=t,t=K)):(us=t,t=K)):(us=t,t=K),fs[i]={nextPos:us,result:t},t)}function h(){var e,r,n,s=37*us+5,u=fs[s];return u?(us=u.nextPos,u.result):(ps++,e=us,r=us,t.substr(us,2)===it?(n=it,us+=2):(n=Y,0===ps&&a(at)),n===Y&&(47===t.charCodeAt(us)?(n=lt,us++):(n=Y,0===ps&&a(ot)),n===Y&&(t.substr(us,3)===ct?(n=ct,us+=3):(n=Y,0===ps&&a(pt)),n===Y&&(t.substr(us,2)===ft?(n=ft,us+=2):(n=Y,0===ps&&a(dt)),n===Y&&(t.substr(us,3)===ht?(n=ht,us+=3):(n=Y,0===ps&&a(vt)),n===Y&&(t.substr(us,2)===At?(n=At,us+=2):(n=Y,0===ps&&a(yt)),n===Y&&(t.substr(us,4)===xt?(n=xt,us+=4):(n=Y,0===ps&&a(bt)),n===Y&&(t.substr(us,3)===Pt?(n=Pt,us+=3):(n=Y,0===ps&&a(gt))))))))),n!==Y&&(n=t.substring(r,us)),r=n,r!==Y?(n=v(),n===Y&&(n=nt),n!==Y?(is=e,r=Ct(r,n),e=r):(us=e,e=K)):(us=e,e=K),ps--,e===Y&&(r=Y,0===ps&&a(ut)),fs[s]={nextPos:us,result:e},e)}function v(){var e,r,n,s,u=37*us+6,i=fs[u];return i?(us=i.nextPos,i.result):(e=us,58===t.charCodeAt(us)?(r=mt,us++):(r=Y,0===ps&&a(Et)),r!==Y?(n=us,s=j(),s!==Y&&(s=t.substring(n,us)),n=s,n!==Y?(is=e,r=St(n),e=r):(us=e,e=K)):(us=e,e=K),fs[u]={nextPos:us,result:e},e)}function A(){var e,r,n=37*us+7,s=fs[n];return s?(us=s.nextPos,s.result):(e=us,r=j(),r!==Y&&(is=e,r=Qt(r)),e=r,e===Y&&(e=us,42===t.charCodeAt(us)?(r=_t,us++):(r=Y,0===ps&&a(Rt)),r!==Y&&(is=e,r=wt()),e=r),fs[n]={nextPos:us,result:e},e)}function y(){var e,r,n,s,u,i,l=37*us+8,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,91===t.charCodeAt(us)?(r=Ft,us++):(r=Y,0===ps&&a(qt)),r!==Y?(n=V(),n!==Y?(s=x(),s!==Y?(u=V(),u!==Y?(93===t.charCodeAt(us)?(i=Tt,us++):(i=Y,0===ps&&a(Lt)),i!==Y?(is=e,r=Nt(s),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),fs[l]={nextPos:us,result:e},e)}function x(){var e,r,n,s,u,i,l,o,c,p,f=37*us+9,d=fs[f];return d?(us=d.nextPos,d.result):(e=us,r=b(),r!==Y?(n=V(),n!==Y?(t.substr(us,2)===kt?(s=kt,us+=2):(s=Y,0===ps&&a(jt)),s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(is=e,r=zt(r,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=us,r=b(),r!==Y?(n=V(),n!==Y?(63===t.charCodeAt(us)?(s=It,us++):(s=Y,0===ps&&a(Ut)),s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(l=V(),l!==Y?(58===t.charCodeAt(us)?(o=mt,us++):(o=Y,0===ps&&a(Et)),o!==Y?(c=V(),c!==Y?(p=b(),p!==Y?(is=e,r=Zt(r,i,p),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=b())),fs[f]={nextPos:us,result:e},e)}function b(){var e,r,n,s,u,i,l=37*us+10,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=P(),r!==Y?(n=V(),n!==Y?(s=us,t.substr(us,2)===Mt?(u=Mt,us+=2):(u=Y,0===ps&&a(Vt)),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(is=e,r=Jt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=P()),fs[l]={nextPos:us,result:e},e)}function P(){var e,r,n,s,u,i,l=37*us+11,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=g(),r!==Y?(n=V(),n!==Y?(s=us,t.substr(us,2)===Bt?(u=Bt,us+=2):(u=Y,0===ps&&a(Gt)),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=P(),i!==Y?(is=e,r=Jt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=g()),fs[l]={nextPos:us,result:e},e)}function g(){var e,r,n,s,u,i,l=37*us+12,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=C(),r!==Y?(n=V(),n!==Y?(s=us,124===t.charCodeAt(us)?(u=Ot,us++):(u=Y,0===ps&&a(Dt)),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=g(),i!==Y?(is=e,r=Yt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=C()),fs[l]={nextPos:us,result:e},e)}function C(){var e,r,n,s,u,i,l=37*us+13,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=m(),r!==Y?(n=V(),n!==Y?(s=us,94===t.charCodeAt(us)?(u=$t,us++):(u=Y,0===ps&&a(Ht)),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=C(),i!==Y?(is=e,r=Yt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=m()),fs[l]={nextPos:us,result:e},e)}function m(){var e,r,n,s,u,i,l=37*us+14,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=E(),r!==Y?(n=V(),n!==Y?(s=us,38===t.charCodeAt(us)?(u=Kt,us++):(u=Y,0===ps&&a(Wt)),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=m(),i!==Y?(is=e,r=Yt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=E()),fs[l]={nextPos:us,result:e},e)}function E(){var e,r,n,s,u,i,l=37*us+15,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=S(),r!==Y?(n=V(),n!==Y?(s=us,t.substr(us,2)===Xt?(u=Xt,us+=2):(u=Y,0===ps&&a(te)),u===Y&&(t.substr(us,2)===ee?(u=ee,us+=2):(u=Y,0===ps&&a(re)),u===Y&&(t.substr(us,2)===ne?(u=ne,us+=2):(u=Y,0===ps&&a(se)),u===Y&&(t.substr(us,2)===ue?(u=ue,us+=2):(u=Y,0===ps&&a(ie)),u===Y&&(60===t.charCodeAt(us)?(u=ae,us++):(u=Y,0===ps&&a(le)),u===Y&&(62===t.charCodeAt(us)?(u=oe,us++):(u=Y,0===ps&&a(ce)),u===Y&&(t.substr(us,2)===pe?(u=pe,us+=2):(u=Y,0===ps&&a(fe)),u===Y&&(t.substr(us,2)===de?(u=de,us+=2):(u=Y,0===ps&&a(he))))))))),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=E(),i!==Y?(is=e,r=ve(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=S()),fs[l]={nextPos:us,result:e},e)}function S(){var e,r,n,s,u,i,l=37*us+16,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=Q(),r!==Y?(n=V(),n!==Y?(s=us,t.substr(us,2)===Ae?(u=Ae,us+=2):(u=Y,0===ps&&a(ye)),u===Y&&(t.substr(us,2)===xe?(u=xe,us+=2):(u=Y,0===ps&&a(be))),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=S(),i!==Y?(is=e,r=Yt(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=Q()),fs[l]={nextPos:us,result:e},e)}function Q(){var e,r,n,s,u,i,l=37*us+17,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=_(),r!==Y?(n=V(),n!==Y?(s=us,43===t.charCodeAt(us)?(u=Pe,us++):(u=Y,0===ps&&a(ge)),u===Y&&(45===t.charCodeAt(us)?(u=Ce,us++):(u=Y,0===ps&&a(me))),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=Q(),i!==Y?(is=e,r=Ee(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=_()),fs[l]={nextPos:us,result:e},e)}function _(){var e,r,n,s,u,i,l=37*us+18,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,r=R(),r!==Y?(n=V(),n!==Y?(s=us,t.substr(us,2)===Se?(u=Se,us+=2):(u=Y,0===ps&&a(Qe)),u===Y&&(42===t.charCodeAt(us)?(u=_t,us++):(u=Y,0===ps&&a(Rt)),u===Y&&(47===t.charCodeAt(us)?(u=lt,us++):(u=Y,0===ps&&a(ot)),u===Y&&(37===t.charCodeAt(us)?(u=_e,us++):(u=Y,0===ps&&a(Re))))),u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(u=V(),u!==Y?(i=_(),i!==Y?(is=e,r=Ee(r,s,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),e===Y&&(e=R()),fs[l]={nextPos:us,result:e},e)}function R(){var e,r,n,s=37*us+19,u=fs[s];return u?(us=u.nextPos,u.result):(e=us,r=us,33===t.charCodeAt(us)?(n=we,us++):(n=Y,0===ps&&a(Fe)),n===Y&&(126===t.charCodeAt(us)?(n=qe,us++):(n=Y,0===ps&&a(Te))),n!==Y&&(n=t.substring(r,us)),r=n,r!==Y?(n=w(),n!==Y?(is=e,r=Le(r,n),e=r):(us=e,e=K)):(us=e,e=K),e===Y&&(e=w()),fs[s]={nextPos:us,result:e},e)}function w(){var t,e=37*us+20,r=fs[e];return r?(us=r.nextPos,r.result):(t=F(),t===Y&&(t=T(),t===Y&&(t=L(),t===Y&&(t=N(),t===Y&&(t=k(),t===Y&&(t=p()))))),fs[e]={nextPos:us,result:t},t)}function F(){var e,r,n,s,u,i,l,o,c=37*us+21,p=fs[c];return p?(us=p.nextPos,p.result):(e=us,r=j(),r!==Y?(n=V(),n!==Y?(40===t.charCodeAt(us)?(s=Ne,us++):(s=Y,0===ps&&a(ke)),s!==Y?(u=V(),u!==Y?(i=q(),i===Y&&(i=nt),i!==Y?(l=V(),l!==Y?(41===t.charCodeAt(us)?(o=je,us++):(o=Y,0===ps&&a(ze)),o!==Y?(is=e,r=Ie(r,i),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),fs[c]={nextPos:us,result:e},e)}function q(){var e,r,n,s,u,i,l,o,c=37*us+22,p=fs[c];if(p)return us=p.nextPos,p.result;if(e=us,r=x(),r!==Y){for(n=[],s=us,u=V(),u!==Y?(44===t.charCodeAt(us)?(i=X,us++):(i=Y,0===ps&&a(tt)),i!==Y?(l=V(),l!==Y?(o=x(),o!==Y?(u=[u,i,l,o],s=u):(us=s,s=K)):(us=s,s=K)):(us=s,s=K)):(us=s,s=K);s!==Y;)n.push(s),s=us,u=V(),u!==Y?(44===t.charCodeAt(us)?(i=X,us++):(i=Y,0===ps&&a(tt)),i!==Y?(l=V(),l!==Y?(o=x(),o!==Y?(u=[u,i,l,o],s=u):(us=s,s=K)):(us=s,s=K)):(us=s,s=K)):(us=s,s=K);n!==Y?(is=e,r=Ue(r,n),e=r):(us=e,e=K)}else us=e,e=K;return fs[c]={nextPos:us,result:e},e}function T(){var e,r,n,s=37*us+23,u=fs[s];return u?(us=u.nextPos,u.result):(ps++,e=us,64===t.charCodeAt(us)?(r=Me,us++):(r=Y,0===ps&&a(Ve)),r!==Y?(n=j(),n!==Y?(is=e,r=Je(n),e=r):(us=e,e=K)):(us=e,e=K),ps--,e===Y&&(r=Y,0===ps&&a(Ze)),fs[s]={nextPos:us,result:e},e)}function L(){var e,r,n,s,u,i,l=37*us+24,o=fs[l];return o?(us=o.nextPos,o.result):(ps++,e=us,123===t.charCodeAt(us)?(r=Ge,us++):(r=Y,0===ps&&a(Oe)),r!==Y?(n=V(),n!==Y?(s=j(),s!==Y?(u=V(),u!==Y?(125===t.charCodeAt(us)?(i=De,us++):(i=Y,0===ps&&a(Ye)),i!==Y?(is=e,r=$e(s),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),ps--,e===Y&&(r=Y,0===ps&&a(Be)),fs[l]={nextPos:us,result:e},e)}function N(){var t,e=37*us+25,r=fs[e];return r?(us=r.nextPos,r.result):(t=z(),t===Y&&(t=U(),t===Y&&(t=Z(),t===Y&&(t=M()))),fs[e]={nextPos:us,result:t},t)}function k(){var e,r,n,s,u,i,l=37*us+26,o=fs[l];return o?(us=o.nextPos,o.result):(e=us,40===t.charCodeAt(us)?(r=Ne,us++):(r=Y,0===ps&&a(ke)),r!==Y?(n=V(),n!==Y?(s=x(),s!==Y?(u=V(),u!==Y?(41===t.charCodeAt(us)?(i=je,us++):(i=Y,0===ps&&a(ze)),i!==Y?(is=e,r=He(s),e=r):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K)):(us=e,e=K),fs[l]={nextPos:us,result:e},e)}function j(){var e,r,n,s,u,i,l,o=37*us+27,c=fs[o];if(c)return us=c.nextPos,c.result;if(ps++,e=us,r=us,n=us,s=us,ps++,u=M(),ps--,u===Y?s=We:(us=s,s=K),s!==Y)if(Xe.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a(tr)),u!==Y){for(i=[],er.test(t.charAt(us))?(l=t.charAt(us),us++):(l=Y,0===ps&&a(rr));l!==Y;)i.push(l),er.test(t.charAt(us))?(l=t.charAt(us),us++):(l=Y,0===ps&&a(rr));i!==Y?(s=[s,u,i],n=s):(us=n,n=K)}else us=n,n=K;else us=n,n=K;return n!==Y&&(n=t.substring(r,us)),r=n,r!==Y&&(is=e,r=nr(r)),e=r,ps--,e===Y&&(r=Y,0===ps&&a(Ke)),fs[o]={nextPos:us,result:e},e}function z(){var e,r,n,s,u,i=37*us+28,l=fs[i];if(l)return us=l.nextPos,l.result;if(ps++,e=us,34===t.charCodeAt(us)?(r=ur,us++):(r=Y,0===ps&&a(ir)),r!==Y){for(n=[],s=I(),s===Y&&(ar.test(t.charAt(us))?(s=t.charAt(us),us++):(s=Y,0===ps&&a(lr)));s!==Y;)n.push(s),s=I(),s===Y&&(ar.test(t.charAt(us))?(s=t.charAt(us),us++):(s=Y,0===ps&&a(lr)));n!==Y?(34===t.charCodeAt(us)?(s=ur,us++):(s=Y,0===ps&&a(ir)),s!==Y?(is=e,r=or(n),e=r):(us=e,e=K)):(us=e,e=K)}else us=e,e=K;if(e===Y)if(e=us,39===t.charCodeAt(us)?(r=cr,us++):(r=Y,0===ps&&a(pr)),r!==Y){for(n=us,s=[],t.substr(us,2)===fr?(u=fr,us+=2):(u=Y,0===ps&&a(dr)),u===Y&&(hr.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a(vr)));u!==Y;)s.push(u),t.substr(us,2)===fr?(u=fr,us+=2):(u=Y,0===ps&&a(dr)),u===Y&&(hr.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a(vr)));s!==Y&&(s=t.substring(n,us)),n=s,n!==Y?(39===t.charCodeAt(us)?(s=cr,us++):(s=Y,0===ps&&a(pr)),s!==Y?(is=e,r=Ar(n),e=r):(us=e,e=K)):(us=e,e=K)}else us=e,e=K;return ps--,e===Y&&(r=Y,0===ps&&a(sr)),fs[i]={nextPos:us,result:e},e}function I(){var e,r,n,s,u,i,l,o,c=37*us+29,p=fs[c];return p?(us=p.nextPos,p.result):(ps++,e=us,t.substr(us,2)===xr?(r=xr,us+=2):(r=Y,0===ps&&a(br)),r!==Y&&(is=e,r=Pr()),e=r,e===Y&&(e=us,t.substr(us,2)===gr?(r=gr,us+=2):(r=Y,0===ps&&a(Cr)),r!==Y&&(is=e,r=mr()),e=r,e===Y&&(e=us,39===t.charCodeAt(us)?(r=cr,us++):(r=Y,0===ps&&a(pr)),r!==Y&&(is=e,r=Er()),e=r,e===Y&&(e=us,t.substr(us,2)===Sr?(r=Sr,us+=2):(r=Y,0===ps&&a(Qr)),r!==Y&&(is=e,r=_r()),e=r,e===Y&&(e=us,t.substr(us,2)===Rr?(r=Rr,us+=2):(r=Y,0===ps&&a(wr)),r!==Y&&(is=e,r=Fr()),e=r,e===Y&&(e=us,t.substr(us,2)===qr?(r=qr,us+=2):(r=Y,0===ps&&a(Tr)),r!==Y&&(is=e,r=Lr()),e=r,e===Y&&(e=us,t.substr(us,2)===Nr?(r=Nr,us+=2):(r=Y,0===ps&&a(kr)),r!==Y&&(is=e,r=jr()),e=r,e===Y&&(e=us,t.substr(us,2)===zr?(r=zr,us+=2):(r=Y,0===ps&&a(Ir)),r!==Y&&(is=e,r=Ur()),e=r,e===Y&&(e=us,t.substr(us,2)===Zr?(r=Zr,us+=2):(r=Y,0===ps&&a(Mr)),r!==Y&&(is=e,r=Vr()),e=r,e===Y&&(e=us,t.substr(us,2)===Jr?(r=Jr,us+=2):(r=Y,0===ps&&a(Br)),r!==Y&&(is=e,r=Gr()),e=r,e===Y&&(e=us,t.substr(us,2)===Or?(r=Or,us+=2):(r=Y,0===ps&&a(Dr)),r!==Y?(n=us,s=us,Yr.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a($r)),u!==Y?(Yr.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a($r)),i!==Y?(u=[u,i],s=u):(us=s,s=K)):(us=s,s=K),s!==Y&&(s=t.substring(n,us)),n=s,n!==Y?(is=e,r=Hr(n),e=r):(us=e,e=K)):(us=e,e=K),e===Y&&(e=us,t.substr(us,2)===Kr?(r=Kr,us+=2):(r=Y,0===ps&&a(Wr)),r!==Y?(n=us,s=us,Yr.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a($r)),u!==Y?(Yr.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a($r)),i!==Y?(Yr.test(t.charAt(us))?(l=t.charAt(us),us++):(l=Y,0===ps&&a($r)),l!==Y?(Yr.test(t.charAt(us))?(o=t.charAt(us),us++):(o=Y,0===ps&&a($r)),o!==Y?(u=[u,i,l,o],s=u):(us=s,s=K)):(us=s,s=K)):(us=s,s=K)):(us=s,s=K),s!==Y&&(s=t.substring(n,us)),n=s,n!==Y?(is=e,r=Hr(n),e=r):(us=e,e=K)):(us=e,e=K)))))))))))),ps--,e===Y&&(r=Y,0===ps&&a(yr)),fs[c]={nextPos:us,result:e},e)}function U(){var e,r,n,s,u,i=37*us+30,l=fs[i];if(l)return us=l.nextPos,l.result;if(ps++,e=us,96===t.charCodeAt(us)?(r=tn,us++):(r=Y,0===ps&&a(en)),r!==Y){for(n=us,s=[],t.substr(us,2)===rn?(u=rn,us+=2):(u=Y,0===ps&&a(nn)),u===Y&&(sn.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a(un)));u!==Y;)s.push(u),t.substr(us,2)===rn?(u=rn,us+=2):(u=Y,0===ps&&a(nn)),u===Y&&(sn.test(t.charAt(us))?(u=t.charAt(us),us++):(u=Y,0===ps&&a(un)));s!==Y&&(s=t.substring(n,us)),n=s,n!==Y?(96===t.charCodeAt(us)?(s=tn,us++):(s=Y,0===ps&&a(en)),s!==Y?(is=e,r=an(n),e=r):(us=e,e=K)):(us=e,e=K)}else us=e,e=K;return ps--,e===Y&&(r=Y,0===ps&&a(Xr)),fs[i]={nextPos:us,result:e},e}function Z(){var e,r,n,s,u,i,l,o,c,p,f,d,h=37*us+31,v=fs[h];if(v)return us=v.nextPos,v.result;if(ps++,e=us,r=us,on.test(t.charAt(us))?(n=t.charAt(us),us++):(n=Y,0===ps&&a(cn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,us)),r=n,r!==Y)if(t.substr(us,2)===pn?(n=pn,us+=2):(n=Y,0===ps&&a(fn)),n!==Y){if(s=us,u=[],dn.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(hn)),i!==Y)for(;i!==Y;)u.push(i),dn.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(hn));else u=K;u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(is=e,r=vn(r,s),e=r):(us=e,e=K)}else us=e,e=K;else us=e,e=K;if(e===Y){if(e=us,r=us,on.test(t.charAt(us))?(n=t.charAt(us),us++):(n=Y,0===ps&&a(cn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,us)),r=n,r!==Y)if(t.substr(us,2)===An?(n=An,us+=2):(n=Y,0===ps&&a(yn)),n!==Y){if(s=us,u=[],xn.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(bn)),i!==Y)for(;i!==Y;)u.push(i),xn.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(bn));else u=K;u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(is=e,r=Pn(r,s),e=r):(us=e,e=K)}else us=e,e=K;else us=e,e=K;if(e===Y){if(e=us,r=us,on.test(t.charAt(us))?(n=t.charAt(us),us++):(n=Y,0===ps&&a(cn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,us)),r=n,r!==Y)if(t.substr(us,2)===gn?(n=gn,us+=2):(n=Y,0===ps&&a(Cn)),n!==Y){if(s=us,u=[],Yr.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a($r)),i!==Y)for(;i!==Y;)u.push(i),Yr.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a($r));else u=K;u!==Y&&(u=t.substring(s,us)),s=u,s!==Y?(is=e,r=mn(r,s),e=r):(us=e,e=K)}else us=e,e=K;else us=e,e=K;if(e===Y){if(e=us,r=us,n=us,on.test(t.charAt(us))?(s=t.charAt(us),us++):(s=Y,0===ps&&a(cn)),s===Y&&(s=nt),s!==Y){for(u=[],En.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(Sn));i!==Y;)u.push(i),En.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(Sn));if(u!==Y)if(46===t.charCodeAt(us)?(i=Qn,us++):(i=Y,0===ps&&a(_n)),i!==Y){if(l=[],En.test(t.charAt(us))?(o=t.charAt(us),us++):(o=Y,0===ps&&a(Sn)),o!==Y)for(;o!==Y;)l.push(o),En.test(t.charAt(us))?(o=t.charAt(us),us++):(o=Y,0===ps&&a(Sn));else l=K;if(l!==Y){if(o=us,Rn.test(t.charAt(us))?(c=t.charAt(us),us++):(c=Y,0===ps&&a(wn)),c!==Y)if(on.test(t.charAt(us))?(p=t.charAt(us),us++):(p=Y,0===ps&&a(cn)),p===Y&&(p=nt),p!==Y){if(f=[],En.test(t.charAt(us))?(d=t.charAt(us),us++):(d=Y,0===ps&&a(Sn)),d!==Y)for(;d!==Y;)f.push(d),En.test(t.charAt(us))?(d=t.charAt(us),us++):(d=Y,0===ps&&a(Sn));else f=K;f!==Y?(c=[c,p,f],o=c):(us=o,o=K)}else us=o,o=K;else us=o,o=K;o===Y&&(o=nt),o!==Y?(s=[s,u,i,l,o],n=s):(us=n,n=K)}else us=n,n=K}else us=n,n=K;else us=n,n=K}else us=n,n=K;if(n!==Y&&(n=t.substring(r,us)),r=n,r!==Y&&(is=e,r=Fn(r)),e=r,e===Y){if(e=us,r=us,n=us,on.test(t.charAt(us))?(s=t.charAt(us),us++):(s=Y,0===ps&&a(cn)),s===Y&&(s=nt),s!==Y){if(u=[],En.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(Sn)),i!==Y)for(;i!==Y;)u.push(i),En.test(t.charAt(us))?(i=t.charAt(us),us++):(i=Y,0===ps&&a(Sn));else u=K;u!==Y?(s=[s,u],n=s):(us=n,n=K)}else us=n,n=K;n!==Y&&(n=t.substring(r,us)),r=n,r!==Y&&(is=e,r=qn(r)),e=r}}}}return ps--,e===Y&&(r=Y,0===ps&&a(ln)),fs[h]={nextPos:us,result:e},e}function M(){var e,r,n=37*us+32,s=fs[n];return s?(us=s.nextPos,s.result):(ps++,e=us,t.substr(us,4)===Ln?(r=Ln,us+=4):(r=Y,0===ps&&a(Nn)),r!==Y&&(is=e,r=kn()),e=r,e===Y&&(e=us,t.substr(us,5)===jn?(r=jn,us+=5):(r=Y,0===ps&&a(zn)),r!==Y&&(is=e,r=In()),e=r,e===Y&&(e=us,t.substr(us,4)===Un?(r=Un,us+=4):(r=Y,0===ps&&a(Zn)),r!==Y&&(is=e,r=Mn()),e=r,e===Y&&(e=us,t.substr(us,3)===Vn?(r=Vn,us+=3):(r=Y,0===ps&&a(Jn)),r!==Y&&(is=e,r=Bn()),e=r,e===Y&&(e=us,t.substr(us,9)===Gn?(r=Gn,us+=9):(r=Y,0===ps&&a(On)),r!==Y&&(is=e,r=Dn()),e=r)))),ps--,e===Y&&(r=Y,0===ps&&a(Tn)),fs[n]={nextPos:us,result:e},e)}function V(){var t,e,r=37*us+33,n=fs[r];if(n)return us=n.nextPos,n.result;for(ps++,t=[],e=J(),e===Y&&(e=B());e!==Y;)t.push(e),e=J(),e===Y&&(e=B());return ps--,t===Y&&(e=Y,0===ps&&a(Yn)),fs[r]={nextPos:us,result:t},t}function J(){var e,r,n,s,u,i,l=37*us+34,o=fs[l];if(o)return us=o.nextPos,o.result;if(ps++,e=us,t.substr(us,2)===Hn?(r=Hn,us+=2):(r=Y,0===ps&&a(Kn)),r!==Y){for(n=[],s=us,u=us,ps++,t.substr(us,2)===Wn?(i=Wn,us+=2):(i=Y,0===ps&&a(Xn)),ps--,i===Y?u=We:(us=u,u=K),u!==Y?(t.length>us?(i=t.charAt(us),us++):(i=Y,0===ps&&a(ts)),i!==Y?(u=[u,i],s=u):(us=s,s=K)):(us=s,s=K);s!==Y;)n.push(s),s=us,u=us,ps++,t.substr(us,2)===Wn?(i=Wn,us+=2):(i=Y,0===ps&&a(Xn)),ps--,i===Y?u=We:(us=u,u=K),u!==Y?(t.length>us?(i=t.charAt(us),us++):(i=Y,0===ps&&a(ts)),i!==Y?(u=[u,i],s=u):(us=s,s=K)):(us=s,s=K);n!==Y?(t.substr(us,2)===Wn?(s=Wn,us+=2):(s=Y,0===ps&&a(Xn)),s!==Y?(r=[r,n,s],e=r):(us=e,e=K)):(us=e,e=K)}else us=e,e=K;return ps--,e===Y&&(r=Y,0===ps&&a($n)),fs[l]={nextPos:us,result:e},e}function B(){var e,r,n=37*us+35,s=fs[n];if(s)return us=s.nextPos,s.result;if(ps++,e=[],rs.test(t.charAt(us))?(r=t.charAt(us),us++):(r=Y,0===ps&&a(ns)),r!==Y)for(;r!==Y;)e.push(r),rs.test(t.charAt(us))?(r=t.charAt(us),us++):(r=Y,0===ps&&a(ns));else e=K;return ps--,e===Y&&(r=Y,0===ps&&a(es)),fs[n]={nextPos:us,result:e},e}function G(){var e,r,n=37*us+36,s=fs[n];return s?(us=s.nextPos,s.result):(ps++,e=us,ps++,t.length>us?(r=t.charAt(us),us++):(r=Y,0===ps&&a(ts)),ps--,r===Y?e=We:(us=e,e=K),ps--,e===Y&&(r=Y,0===ps&&a(ss)),fs[n]={nextPos:us,result:e},e)}var O,D=arguments.length>1?arguments[1]:{},Y={},$={query:o},H=o,K=Y,W=function(t){return t},X=",",tt={type:"literal",value:",",description:'","'},et=function(t,e){return hs("Query").add(ds(t,e,3))},rt=function(t,e){return hs("Path").add(ds(t,e,1))},nt=null,st=function(t,e,r){return hs("Step").add(t,e,r)},ut={type:"other",description:"axis"},it="//",at={type:"literal",value:"//",description:'"//"'},lt="/",ot={type:"literal",value:"/",description:'"/"'},ct="+//",pt={type:"literal",value:"+//",description:'"+//"'},ft="+/",dt={type:"literal",value:"+/",description:'"+/"'},ht="-//",vt={type:"literal",value:"-//",description:'"-//"'},At="-/",yt={type:"literal",value:"-/",description:'"-/"'},xt="..//",bt={type:"literal",value:"..//",description:'"..//"'},Pt="../",gt={type:"literal",value:"../",description:'"../"'},Ct=function(t,e){return hs("Axis").set({op:t,type:null!==e?e:"*"})},mt=":",Et={type:"literal",value:":",description:'":"'},St=function(t){return t},Qt=function(t){return hs("Match").merge(t)},_t="*",Rt={type:"literal",value:"*",description:'"*"'},wt=function(){return hs("Match").set({id:"*"})},Ft="[",qt={type:"literal",value:"[",description:'"["'},Tt="]",Lt={type:"literal",value:"]",description:'"]"'},Nt=function(t){return hs("Filter").add(t)},kt="?:",jt={type:"literal",value:"?:",description:'"?:"'},zt=function(t,e){return hs("ConditionalBinary").add(t,e)},It="?",Ut={type:"literal",value:"?",description:'"?"'},Zt=function(t,e,r){return hs("ConditionalTernary").add(t,e,r)},Mt="||",Vt={type:"literal",value:"||",description:'"||"'},Jt=function(t,e,r){return hs("Logical").set({op:e}).add(t,r)},Bt="&&",Gt={type:"literal",value:"&&",description:'"&&"'},Ot="|",Dt={type:"literal",value:"|",description:'"|"'},Yt=function(t,e,r){return hs("Bitwise").set({op:e}).add(t,r)},$t="^",Ht={type:"literal",value:"^",description:'"^"'},Kt="&",Wt={type:"literal",value:"&",description:'"&"'},Xt="==",te={type:"literal",value:"==",description:'"=="'},ee="!=",re={type:"literal",value:"!=",description:'"!="'},ne="<=",se={type:"literal",value:"<=",description:'"<="'},ue=">=",ie={type:"literal",value:">=",description:'">="'},ae="<",le={type:"literal",value:"<",description:'"<"'},oe=">",ce={type:"literal",value:">",description:'">"'},pe="=~",fe={type:"literal",value:"=~",description:'"=~"'},de="!~",he={type:"literal",value:"!~",description:'"!~"'},ve=function(t,e,r){return hs("Relational").set({op:e}).add(t,r)},Ae="<<",ye={type:"literal",value:"<<",description:'"<<"'},xe=">>",be={type:"literal",value:">>",description:'">>"'},Pe="+",ge={type:"literal",value:"+",description:'"+"'},Ce="-",me={type:"literal",value:"-",description:'"-"'},Ee=function(t,e,r){return hs("Arithmetical").set({op:e}).add(t,r)},Se="**",Qe={type:"literal",value:"**",description:'"**"'},_e="%",Re={type:"literal",value:"%",description:'"%"'},we="!",Fe={type:"literal",value:"!",description:'"!"'},qe="~",Te={type:"literal",value:"~",description:'"~"'},Le=function(t,e){return hs("Unary").set({op:t}).add(e)},Ne="(",ke={type:"literal",value:"(",description:'"("'},je=")",ze={type:"literal",value:")",description:'")"'},Ie=function(t,e){return hs("FuncCall").merge(t).add(e)},Ue=function(t,e){return ds(t,e,3)},Ze={type:"other",description:"node attribute"},Me="@",Ve={type:"literal",value:"@",description:'"@"'},Je=function(t){return hs("Attribute").merge(t)},Be={type:"other",description:"query parameter reference"},Ge="{",Oe={type:"literal",value:"{",description:'"{"'},De="}",Ye={type:"literal",value:"}",description:'"}"'},$e=function(t){return hs("Param").merge(t)},He=function(t){return t},Ke={type:"other",description:"identifier"},We=void 0,Xe=/^[a-zA-Z_]/,tr={type:"class",value:"[a-zA-Z_]",description:"[a-zA-Z_]"},er=/^[a-zA-Z0-9_\-]/,rr={type:"class",value:"[a-zA-Z0-9_\\-]",description:"[a-zA-Z0-9_\\-]"},nr=function(t){return hs("Identifier").set({id:t})},sr={type:"other",description:"quoted string literal"},ur='"',ir={type:"literal",value:'"',description:'"\\""'},ar=/^[^"]/,lr={type:"class",value:'[^"]',description:'[^"]'},or=function(t){return hs("LiteralString").set({value:t.join("")})},cr="'",pr={type:"literal",value:"'",description:'"\'"'},fr="\\'",dr={type:"literal",value:"\\'",description:'"\\\\\'"'},hr=/^[^']/,vr={type:"class",value:"[^']",description:"[^']"},Ar=function(t){return hs("LiteralString").set({value:t.replace(/\\'/g,"'")})},yr={type:"other",description:"escaped string character"},xr="\\\\",br={type:"literal",value:"\\\\",description:'"\\\\\\\\"'},Pr=function(){return"\\"},gr='\\"',Cr={type:"literal",value:'\\"',description:'"\\\\\\""'},mr=function(){return'"'},Er=function(){return"'"},Sr="\\b",Qr={type:"literal",value:"\\b",description:'"\\\\b"'},_r=function(){return"\b"},Rr="\\v",wr={type:"literal",value:"\\v",description:'"\\\\v"'},Fr=function(){return""},qr="\\f",Tr={type:"literal",value:"\\f",description:'"\\\\f"'},Lr=function(){return"\f"},Nr="\\t",kr={type:"literal",value:"\\t",description:'"\\\\t"'},jr=function(){return"	"},zr="\\r",Ir={type:"literal",value:"\\r",description:'"\\\\r"'},Ur=function(){return"\r"},Zr="\\n",Mr={type:"literal",value:"\\n",description:'"\\\\n"'},Vr=function(){return"\n"},Jr="\\e",Br={type:"literal",value:"\\e",description:'"\\\\e"'},Gr=function(){return""},Or="\\x",Dr={type:"literal",value:"\\x",description:'"\\\\x"'},Yr=/^[0-9a-fA-F]/,$r={type:"class",value:"[0-9a-fA-F]",description:"[0-9a-fA-F]"},Hr=function(t){return String.fromCharCode(parseInt(t,16))},Kr="\\u",Wr={type:"literal",value:"\\u",description:'"\\\\u"'},Xr={type:"other",description:"regular expression literal"},tn="`",en={type:"literal",value:"`",description:'"`"'},rn="\\`",nn={type:"literal",value:"\\`",description:'"\\\\`"'},sn=/^[^`]/,un={type:"class",value:"[^`]",description:"[^`]"},an=function(t){var e;try{e=new RegExp(t.replace(/\\`/g,"`"))}catch(r){u(r.message)}return hs("LiteralRegExp").set({value:e})},ln={type:"other",description:"numeric literal"},on=/^[+\-]/,cn={type:"class",value:"[+\\-]",description:"[+\\-]"},pn="0b",fn={type:"literal",value:"0b",description:'"0b"'},dn=/^[01]/,hn={type:"class",value:"[01]",description:"[01]"},vn=function(t,e){return hs("LiteralNumber").set({value:parseInt(t+e,2)})},An="0o",yn={type:"literal",value:"0o",description:'"0o"'},xn=/^[0-7]/,bn={type:"class",value:"[0-7]",description:"[0-7]"},Pn=function(t,e){return hs("LiteralNumber").set({value:parseInt(t+e,8)})},gn="0x",Cn={type:"literal",value:"0x",description:'"0x"'},mn=function(t,e){return hs("LiteralNumber").set({value:parseInt(t+e,16)})},En=/^[0-9]/,Sn={type:"class",value:"[0-9]",description:"[0-9]"},Qn=".",_n={type:"literal",value:".",description:'"."'},Rn=/^[eE]/,wn={type:"class",value:"[eE]",description:"[eE]"},Fn=function(t){return hs("LiteralNumber").set({value:parseFloat(t)})},qn=function(t){return hs("LiteralNumber").set({value:parseInt(t,10)})},Tn={type:"other",description:"global value"},Ln="true",Nn={type:"literal",value:"true",description:'"true"'},kn=function(){return hs("LiteralValue").set({value:!0})},jn="false",zn={type:"literal",value:"false",description:'"false"'},In=function(){return hs("LiteralValue").set({value:!1})},Un="null",Zn={type:"literal",value:"null",description:'"null"'},Mn=function(){return hs("LiteralValue").set({value:null})},Vn="NaN",Jn={type:"literal",value:"NaN",description:'"NaN"'},Bn=function(){return hs("LiteralValue").set({value:NaN})},Gn="undefined",On={type:"literal",value:"undefined",description:'"undefined"'},Dn=function(){return hs("LiteralValue").set({value:void 0})},Yn={type:"other",description:"optional blank"},$n={type:"other",description:"multi-line comment"},Hn="/*",Kn={type:"literal",value:"/*",description:'"/*"'},Wn="*/",Xn={type:"literal",value:"*/",description:'"*/"'},ts={type:"any",description:"any character"},es={type:"other",description:"any whitespaces"},rs=/^[ \t\r\n]/,ns={type:"class",value:"[ \\t\\r\\n]",description:"[ \\t\\r\\n]"},ss={type:"other",description:"end of file"},us=0,is=0,as=0,ls={line:1,column:1,seenCR:!1},os=0,cs=[],ps=0,fs={};if("startRule"in D){if(!(D.startRule in $))throw new Error("Can't start parsing from rule \""+D.startRule+'".');H=$[D.startRule]}var ds=D.util.makeUnroll(n,s,r,e),hs=D.util.makeAST(n,s,r,D);if(O=H(),O!==Y&&us===t.length)return O;throw O!==Y&&us<t.length&&a({type:"end",description:"end of input"}),l(null,cs,os)}return t(e,Error),{SyntaxError:e,parse:r}}(),ASTQQuery=function(){function t(e){_classCallCheck(this,t),this.asty=new ASTY,this.ast=null,e&&this.compile(e)}return _createClass(t,[{key:"compile",value:function(t,e){var r=this;e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=PEGUtil.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,e,n,s){return r.asty.create.apply(r.asty,s).pos(t,e,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+PEGUtil.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){return this.ast.dump()}},{key:"execute",value:function(t,e,r,n,s){s&&console.log("ASTQ: execute: +--------------------------------------------------------------+----------------------------------------");var u=new _astqQueryExecJs2["default"](e,r,n,s);
return u.execQuery(this.ast,t)}}]),t}();exports["default"]=ASTQQuery,module.exports=exports["default"];
},{"./astq-query-exec.js":10,"asty":1,"pegjs-util":3}],13:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),ASTQUtil=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function t(e,r){var n=0>r?-r:r;if(e.length>n)e=e.substr(0,n);else{var t=Array(n+1-e.length).join(" ");e=0>r?e+t:t+e}return e}},{key:"truthy",value:function(e){var t=void 0;switch(typeof e){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if(typeof e!==t)try{switch(t){case"boolean":"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"==typeof e&&e instanceof RegExp||(e=new RegExp(e))}}catch(r){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();exports["default"]=ASTQUtil,module.exports=exports["default"];
},{}],14:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var version={major:1,minor:4,micro:8,date:20150801};exports["default"]=version,module.exports=exports["default"];
},{}],15:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var s=t[r];s.enumerable=s.enumerable||!1,s.configurable=!0,"value"in s&&(s.writable=!0),Object.defineProperty(e,s.key,s)}}return function(t,r,s){return r&&e(t.prototype,r),s&&e(t,s),t}}(),_astqAdapterJs=_dereq_("./astq-adapter.js"),_astqAdapterJs2=_interopRequireDefault(_astqAdapterJs),_astqAdapterAstyJs=_dereq_("./astq-adapter-asty.js"),_astqAdapterAstyJs2=_interopRequireDefault(_astqAdapterAstyJs),_astqAdapterMozastJs=_dereq_("./astq-adapter-mozast.js"),_astqAdapterMozastJs2=_interopRequireDefault(_astqAdapterMozastJs),_astqAdapterXmldomJs=_dereq_("./astq-adapter-xmldom.js"),_astqAdapterXmldomJs2=_interopRequireDefault(_astqAdapterXmldomJs),_astqFuncsJs=_dereq_("./astq-funcs.js"),_astqFuncsJs2=_interopRequireDefault(_astqFuncsJs),_astqFuncsStdJs=_dereq_("./astq-funcs-std.js"),_astqFuncsStdJs2=_interopRequireDefault(_astqFuncsStdJs),_astqQueryJs=_dereq_("./astq-query.js"),_astqQueryJs2=_interopRequireDefault(_astqQueryJs),_astqVersionJs=_dereq_("./astq-version.js"),_astqVersionJs2=_interopRequireDefault(_astqVersionJs),CacheLRU=_dereq_("cache-lru"),ASTQ=function(){function e(){_classCallCheck(this,e),this._adapter=new _astqAdapterJs2["default"],this._adapter.register(_astqAdapterMozastJs2["default"]),this._adapter.register(_astqAdapterXmldomJs2["default"]),this._adapter.register(_astqAdapterAstyJs2["default"]),this._funcs=new _astqFuncsJs2["default"];for(var t in _astqFuncsStdJs2["default"])this.func(t,_astqFuncsStdJs2["default"][t]);this._cache=new CacheLRU}return _createClass(e,[{key:"version",value:function(){return _astqVersionJs2["default"]}},{key:"adapter",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#adapter: invalid number of arguments");return this._adapter.unregister(),this._adapter.register(e),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&(r=new _astqQueryJs2["default"],r.compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,s){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===s&&(s=!1);var a=this._adapter.select(e);if(void 0===a)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,a,r,this._funcs,s)}},{key:"query",value:function(e,t,r,s){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===s&&(s=!1),this.execute(e,this.compile(t,s),r,s)}}]),e}();exports["default"]=ASTQ,module.exports=exports["default"];
},{"./astq-adapter-asty.js":4,"./astq-adapter-mozast.js":5,"./astq-adapter-xmldom.js":6,"./astq-adapter.js":7,"./astq-funcs-std.js":8,"./astq-funcs.js":9,"./astq-query.js":12,"./astq-version.js":14,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15])(15)
});


//# sourceMappingURL=astq.browser.map